<template>
  <v-dialog v-model="show" max-width="480px">
    <v-card>
      <v-card-title>
        {{ value.title }}
      </v-card-title>
      <v-card-text>
        <v-form ref="form" v-model="valid" lazy-validation>
          <div style="padding:10px">
            <label>
              Account Name*
            </label>
            <v-text-field
              v-model="name"
              :rules="rules"
              placeholder="e.g. cash, bank, etc"
              required
            ></v-text-field>

            <label>
              Type*
            </label>
            <v-select
              v-model="type"
              :items="listType"
              :rules="rules"
              placeholder="select type"
              required
            ></v-select>

            <label>
              Description*
            </label>
            <v-text-field
              v-model="description"
              placeholder="Input your description"
              :rules="rules"
              required
            ></v-text-field>
          </div>

          <div align="right">
            <v-btn
              color="#babbba"
              outlined
              rounded
              @click.stop="show = false"
              class="btn-custom"
            >
              Batal
            </v-btn>

            &nbsp;

            <v-btn
              color="#90ba45"
              rounded
              dark
              :loading="loading"
              @click="insertData()"
              class="btn-custom"
            >
              Simpan
            </v-btn>
          </div>
        </v-form>
      </v-card-text>
    </v-card>
  </v-dialog>
</template>

<script>
export default {
  props: { value: { type: Object } },

  computed: {
    show: {
      get() {
        let self = this;
        self.clear();
        if (self.value["data"]) {
          self.name = self.value["data"]["name"];
          self.type = self.value["data"]["type"];
          self.description = self.value["data"]["Description"];
        }
        return self.value["val"];
      },
      set(value) {
        this.$emit("input", value);
      },
    },
  },
  methods: {
    processForm() {
      let value = this.comment;
      this.$emit("event", value);
    },
    async insertData() {
      let self = this;
      let res = null;
      self.loading = true;

      try {
        if (self.$refs.form.validate()) {
          let url = self.base_url + "api/v1/finance-accounts";
          let data = {
            name: self.name,
            description: self.description,
            type: self.type,
          };

          if (self.value.tipe == "insert") {
            res = await self.axios.post(url, data, {
              headers: {
                Authorization: "Bearer " + self.token,
                "Content-Type": "application/json;charset=UTF-8",
              },
            });
          } else {
            url =
              self.base_url +
              "api/v1/finance-accounts/" +
              this.value["data"]["id"];

            res = await self.axios.put(url, data, {
              headers: {
                Authorization: "Bearer " + self.token,
                "Content-Type": "application/json;charset=UTF-8",
              },
            });
          }
        }
      } catch (err) {
        alert(JSON.stringify(err.response.data));
      } finally {
        self.finish(res);
      }
    },
    finish(res) {
      this.loading = false;
      this.$emit("event", res);
      this.clear();
      console(res);
    },
    clear() {
      this.name = "";
      this.type = "";
      this.description = "";
    },
  },
  data: function() {
    return {
      loading: false,
      listType: [
        "Cash",
        "Expense",
        "Bank",
        "E-Wallet",
        "Credit Card",
        "Voucher",
        "E-Money"
      ],
      rules: [(v) => !!v || "Form is required"],
      token: localStorage.getItem("token")
    };
  },
};
</script>
